// Define the configuraton for the I/O
var DIGITAL_INPUTS_LOCATION = '/sys/class/gpio/gpio';
var DIGITAL_INPUTS_BASEGPIO = 448;// Default=448
var DIGITAL_INPUTS_POINTS = 48;// Default=48

// The following array holds, in memory, the current value (as 0 or 1 values)
var digitalInputsArray = [
    { "Address" : "0", "Name" : "Name", "Value": 0 , "TempValue": 0, "ValueChanged": false, "HoldTimer": 0, "Enabled": "FALSE", "SendEvents": "FALSE", "Polarity": "Normally Open", "HoldTime": 0 , "TimeChanged": 0 }, //376
    { "Address" : "1", "Name" : "Name", "Value": 0 , "TempValue": 0, "ValueChanged": false, "HoldTimer": 0, "Enabled": "FALSE", "SendEvents": "FALSE", "Polarity": "Normally Open", "HoldTime": 0 , "TimeChanged": 0 }, 
    { "Address" : "2", "Name" : "Name", "Value": 0 , "TempValue": 0, "ValueChanged": false, "HoldTimer": 0, "Enabled": "FALSE", "SendEvents": "FALSE", "Polarity": "Normally Open", "HoldTime": 0 , "TimeChanged": 0 }, 
    { "Address" : "3", "Name" : "Name", "Value": 0 , "TempValue": 0, "ValueChanged": false, "HoldTimer": 0, "Enabled": "FALSE", "SendEvents": "FALSE", "Polarity": "Normally Open", "HoldTime": 0 , "TimeChanged": 0 },
    { "Address" : "4", "Name" : "Name", "Value": 0 , "TempValue": 0, "ValueChanged": false, "HoldTimer": 0, "Enabled": "FALSE", "SendEvents": "FALSE", "Polarity": "Normally Open", "HoldTime": 0 , "TimeChanged": 0 }, 
    { "Address" : "5", "Name" : "Name", "Value": 0 , "TempValue": 0, "ValueChanged": false, "HoldTimer": 0, "Enabled": "FALSE", "SendEvents": "FALSE", "Polarity": "Normally Open", "HoldTime": 0 , "TimeChanged": 0 }, 
    { "Address" : "6", "Name" : "Name", "Value": 0 , "TempValue": 0, "ValueChanged": false, "HoldTimer": 0, "Enabled": "FALSE", "SendEvents": "FALSE", "Polarity": "Normally Open", "HoldTime": 0 , "TimeChanged": 0 }, 
    { "Address" : "7", "Name" : "Name", "Value": 0 , "TempValue": 0, "ValueChanged": false, "HoldTimer": 0, "Enabled": "FALSE", "SendEvents": "FALSE", "Polarity": "Normally Open", "HoldTime": 0 , "TimeChanged": 0 },

    { "Address" : "8", "Name" : "Name", "Value": 0 , "TempValue": 0, "ValueChanged": false, "HoldTimer": 0, "Enabled": "FALSE", "SendEvents": "FALSE", "Polarity": "Normally Open", "HoldTime": 0 , "TimeChanged": 0 }, 
    { "Address" : "9", "Name" : "Name", "Value": 0 , "TempValue": 0, "ValueChanged": false, "HoldTimer": 0, "Enabled": "FALSE", "SendEvents": "FALSE", "Polarity": "Normally Open", "HoldTime": 0 , "TimeChanged": 0 }, 
    { "Address" : "10", "Name" : "Name", "Value": 0 , "TempValue": 0, "ValueChanged": false, "HoldTimer": 0, "Enabled": "FALSE", "SendEvents": "FALSE", "Polarity": "Normally Open", "HoldTime": 0 , "TimeChanged": 0 }, 
    { "Address" : "11", "Name" : "Name", "Value": 0 , "TempValue": 0, "ValueChanged": false, "HoldTimer": 0, "Enabled": "FALSE", "SendEvents": "FALSE", "Polarity": "Normally Open", "HoldTime": 0 , "TimeChanged": 0 },
    { "Address" : "12", "Name" : "Name", "Value": 0 , "TempValue": 0, "ValueChanged": false, "HoldTimer": 0, "Enabled": "FALSE", "SendEvents": "FALSE", "Polarity": "Normally Open", "HoldTime": 0 , "TimeChanged": 0 }, 
    { "Address" : "13", "Name" : "Name", "Value": 0 , "TempValue": 0, "ValueChanged": false, "HoldTimer": 0, "Enabled": "FALSE", "SendEvents": "FALSE", "Polarity": "Normally Open", "HoldTime": 0 , "TimeChanged": 0 }, 
    { "Address" : "14", "Name" : "Name", "Value": 0 , "TempValue": 0, "ValueChanged": false, "HoldTimer": 0, "Enabled": "FALSE", "SendEvents": "FALSE", "Polarity": "Normally Open", "HoldTime": 0 , "TimeChanged": 0 }, 
    { "Address" : "15", "Name" : "Name", "Value": 0 , "TempValue": 0, "ValueChanged": false, "HoldTimer": 0, "Enabled": "FALSE", "SendEvents": "FALSE", "Polarity": "Normally Open", "HoldTime": 0 , "TimeChanged": 0 },

    { "Address" : "16", "Name" : "Name", "Value": 0 , "TempValue": 0, "ValueChanged": false, "HoldTimer": 0, "Enabled": "FALSE", "SendEvents": "FALSE", "Polarity": "Normally Open", "HoldTime": 0 , "TimeChanged": 0 }, 
    { "Address" : "17", "Name" : "Name", "Value": 0 , "TempValue": 0, "ValueChanged": false, "HoldTimer": 0, "Enabled": "FALSE", "SendEvents": "FALSE", "Polarity": "Normally Open", "HoldTime": 0 , "TimeChanged": 0 }, 
    { "Address" : "18", "Name" : "Name", "Value": 0 , "TempValue": 0, "ValueChanged": false, "HoldTimer": 0, "Enabled": "FALSE", "SendEvents": "FALSE", "Polarity": "Normally Open", "HoldTime": 0 , "TimeChanged": 0 }, 
    { "Address" : "19", "Name" : "Name", "Value": 0 , "TempValue": 0, "ValueChanged": false, "HoldTimer": 0, "Enabled": "FALSE", "SendEvents": "FALSE", "Polarity": "Normally Open", "HoldTime": 0 , "TimeChanged": 0 },
    { "Address" : "20", "Name" : "Name", "Value": 0 , "TempValue": 0, "ValueChanged": false, "HoldTimer": 0, "Enabled": "FALSE", "SendEvents": "FALSE", "Polarity": "Normally Open", "HoldTime": 0 , "TimeChanged": 0 }, 
    { "Address" : "21", "Name" : "Name", "Value": 0 , "TempValue": 0, "ValueChanged": false, "HoldTimer": 0, "Enabled": "FALSE", "SendEvents": "FALSE", "Polarity": "Normally Open", "HoldTime": 0 , "TimeChanged": 0 }, 
    { "Address" : "22", "Name" : "Name", "Value": 0 , "TempValue": 0, "ValueChanged": false, "HoldTimer": 0, "Enabled": "FALSE", "SendEvents": "FALSE", "Polarity": "Normally Open", "HoldTime": 0 , "TimeChanged": 0 }, 
    { "Address" : "23", "Name" : "Name", "Value": 0 , "TempValue": 0, "ValueChanged": false, "HoldTimer": 0, "Enabled": "FALSE", "SendEvents": "FALSE", "Polarity": "Normally Open", "HoldTime": 0 , "TimeChanged": 0 },

    { "Address" : "24", "Name" : "Name", "Value": 0 , "TempValue": 0, "ValueChanged": false, "HoldTimer": 0, "Enabled": "FALSE", "SendEvents": "FALSE", "Polarity": "Normally Open", "HoldTime": 0 , "TimeChanged": 0 }, //352
    { "Address" : "25", "Name" : "Name", "Value": 0 , "TempValue": 0, "ValueChanged": false, "HoldTimer": 0, "Enabled": "FALSE", "SendEvents": "FALSE", "Polarity": "Normally Open", "HoldTime": 0 , "TimeChanged": 0 }, 
    { "Address" : "26", "Name" : "Name", "Value": 0 , "TempValue": 0, "ValueChanged": false, "HoldTimer": 0, "Enabled": "FALSE", "SendEvents": "FALSE", "Polarity": "Normally Open", "HoldTime": 0 , "TimeChanged": 0 }, 
    { "Address" : "27", "Name" : "Name", "Value": 0 , "TempValue": 0, "ValueChanged": false, "HoldTimer": 0, "Enabled": "FALSE", "SendEvents": "FALSE", "Polarity": "Normally Open", "HoldTime": 0 , "TimeChanged": 0 },
    { "Address" : "28", "Name" : "Name", "Value": 0 , "TempValue": 0, "ValueChanged": false, "HoldTimer": 0, "Enabled": "FALSE", "SendEvents": "FALSE", "Polarity": "Normally Open", "HoldTime": 0 , "TimeChanged": 0 }, 
    { "Address" : "29", "Name" : "Name", "Value": 0 , "TempValue": 0, "ValueChanged": false, "HoldTimer": 0, "Enabled": "FALSE", "SendEvents": "FALSE", "Polarity": "Normally Open", "HoldTime": 0 , "TimeChanged": 0 }, 
    { "Address" : "30", "Name" : "Name", "Value": 0 , "TempValue": 0, "ValueChanged": false, "HoldTimer": 0, "Enabled": "FALSE", "SendEvents": "FALSE", "Polarity": "Normally Open", "HoldTime": 0 , "TimeChanged": 0 }, 
    { "Address" : "31", "Name" : "Name", "Value": 0 , "TempValue": 0, "ValueChanged": false, "HoldTimer": 0, "Enabled": "FALSE", "SendEvents": "FALSE", "Polarity": "Normally Open", "HoldTime": 0 , "TimeChanged": 0 },

    { "Address" : "32", "Name" : "Name", "Value": 0 , "TempValue": 0, "ValueChanged": false, "HoldTimer": 0, "Enabled": "FALSE", "SendEvents": "FALSE", "Polarity": "Normally Open", "HoldTime": 0 , "TimeChanged": 0 }, 
    { "Address" : "33", "Name" : "Name", "Value": 0 , "TempValue": 0, "ValueChanged": false, "HoldTimer": 0, "Enabled": "FALSE", "SendEvents": "FALSE", "Polarity": "Normally Open", "HoldTime": 0 , "TimeChanged": 0 }, 
    { "Address" : "34", "Name" : "Name", "Value": 0 , "TempValue": 0, "ValueChanged": false, "HoldTimer": 0, "Enabled": "FALSE", "SendEvents": "FALSE", "Polarity": "Normally Open", "HoldTime": 0 , "TimeChanged": 0 }, 
    { "Address" : "35", "Name" : "Name", "Value": 0 , "TempValue": 0, "ValueChanged": false, "HoldTimer": 0, "Enabled": "FALSE", "SendEvents": "FALSE", "Polarity": "Normally Open", "HoldTime": 0 , "TimeChanged": 0 },
    { "Address" : "36", "Name" : "Name", "Value": 0 , "TempValue": 0, "ValueChanged": false, "HoldTimer": 0, "Enabled": "FALSE", "SendEvents": "FALSE", "Polarity": "Normally Open", "HoldTime": 0 , "TimeChanged": 0 }, 
    { "Address" : "37", "Name" : "Name", "Value": 0 , "TempValue": 0, "ValueChanged": false, "HoldTimer": 0, "Enabled": "FALSE", "SendEvents": "FALSE", "Polarity": "Normally Open", "HoldTime": 0 , "TimeChanged": 0 }, 
    { "Address" : "38", "Name" : "Name", "Value": 0 , "TempValue": 0, "ValueChanged": false, "HoldTimer": 0, "Enabled": "FALSE", "SendEvents": "FALSE", "Polarity": "Normally Open", "HoldTime": 0 , "TimeChanged": 0 }, 
    { "Address" : "39", "Name" : "Name", "Value": 0 , "TempValue": 0, "ValueChanged": false, "HoldTimer": 0, "Enabled": "FALSE", "SendEvents": "FALSE", "Polarity": "Normally Open", "HoldTime": 0 , "TimeChanged": 0 },

    { "Address" : "40", "Name" : "Name", "Value": 0 , "TempValue": 0, "ValueChanged": false, "HoldTimer": 0, "Enabled": "FALSE", "SendEvents": "FALSE", "Polarity": "Normally Open", "HoldTime": 0 , "TimeChanged": 0 }, 
    { "Address" : "41", "Name" : "Name", "Value": 0 , "TempValue": 0, "ValueChanged": false, "HoldTimer": 0, "Enabled": "FALSE", "SendEvents": "FALSE", "Polarity": "Normally Open", "HoldTime": 0 , "TimeChanged": 0 }, 
    { "Address" : "42", "Name" : "Name", "Value": 0 , "TempValue": 0, "ValueChanged": false, "HoldTimer": 0, "Enabled": "FALSE", "SendEvents": "FALSE", "Polarity": "Normally Open", "HoldTime": 0 , "TimeChanged": 0 }, 
    { "Address" : "43", "Name" : "Name", "Value": 0 , "TempValue": 0, "ValueChanged": false, "HoldTimer": 0, "Enabled": "FALSE", "SendEvents": "FALSE", "Polarity": "Normally Open", "HoldTime": 0 , "TimeChanged": 0 },
    { "Address" : "44", "Name" : "Name", "Value": 0 , "TempValue": 0, "ValueChanged": false, "HoldTimer": 0, "Enabled": "FALSE", "SendEvents": "FALSE", "Polarity": "Normally Open", "HoldTime": 0 , "TimeChanged": 0 }, 
    { "Address" : "45", "Name" : "Name", "Value": 0 , "TempValue": 0, "ValueChanged": false, "HoldTimer": 0, "Enabled": "FALSE", "SendEvents": "FALSE", "Polarity": "Normally Open", "HoldTime": 0 , "TimeChanged": 0 }, 
    { "Address" : "46", "Name" : "Name", "Value": 0 , "TempValue": 0, "ValueChanged": false, "HoldTimer": 0, "Enabled": "FALSE", "SendEvents": "FALSE", "Polarity": "Normally Open", "HoldTime": 0 , "TimeChanged": 0 }, 
    { "Address" : "47", "Name" : "Name", "Value": 0 , "TempValue": 0, "ValueChanged": false, "HoldTimer": 0, "Enabled": "FALSE", "SendEvents": "FALSE", "Polarity": "Normally Open", "HoldTime": 0 , "TimeChanged": 0 }
];

// Requires
var fs = require('fs');
var moment = require('moment');
var SmtpManager = [];

// Initialize the digital inputs upon system start
//      - Checks if database table exists, if not creates the table and fills it with default data for each point
//      - Else reads from the database and updates digitalInputsArray
exports.InitializeDigitalInputs = function (smtp, db, io, logger, callback) {
    // Initialize SmtpManager
    SmtpManager = smtp;

    // Try getting the DigitalInputs table
    db.get("SELECT name FROM sqlite_master WHERE type='table' AND name='DigitalInputs'", function (err, rows) {
        if (err !== null) {
            logger.error('Digital Inputs - Initialize Error (Check)=' + JSON.stringify(err));
        }
        else if (typeof rows === "undefined") {
            // We read nothing, so let's create the table ...
            logger.info("Digital Inputs - Initialize by creating database table ...");
            db.exec("CREATE TABLE if not exists DigitalInputs (Address INTEGER, Name TEXT, Value TEXT, Enabled TEXT, SendEvents TEXT, Polarity TEXT, HoldTime INTEGER, TimeChanged TEXT )", function (err) {
                if (err !== null) {
                    logger.error('Digital Inputs - Initialize Error (Create)=' + JSON.stringify(err));
                }
                else {
                    var timeChanged = moment();// Record the create time as the last time the I/O point value was changed
                    
                    // Created the table, now add data ...
                    db.run("BEGIN")
                    for (var i = 0; i < DIGITAL_INPUTS_POINTS; i++) {
                        // Initialize the array
                        UpdateDigitalInputConfiguration(i, "Digital Input " + (i + 1), 0, "FALSE", "FALSE", "Normally Open", 0, timeChanged, io, logger);
                        digitalInputsArray[i].TempValue = -1;
                        digitalInputsArray[i].ValueChanged = false;
                        digitalInputsArray[i].HoldTimer = timeChanged;
                        
                        // Initialize the database
                        insertStatement = i + ", 'Digital Input " + (i + 1) + "', '0', 'FALSE', 'FALSE', 'Normally Open', 0, '" + timeChanged + "'";
                        db.run("INSERT INTO DigitalInputs (Address, Name, Value, Enabled, SendEvents, Polarity, HoldTime, TimeChanged) VALUES (" + insertStatement + ")", function (err) {
                            if (err !== null) {
                                logger.error('Digital Inputs - Initialize Error (Insert)=' + JSON.stringify(err));
                            }
                        });
                    }
                    db.run("COMMIT");
                    
                    // Digital Inputs table created
                    if (typeof callback == "function") {
                        logger.info('Digital Inputs - Initialized new database table');
                        callback();
                    }
                }
            });
        }
        else {
            // Read from the database and populate the digitalInputsArray
            logger.info("Digital Inputs - Initialize by reading database ...");
            db.each("SELECT rowid as id, Address, Name, Value, Enabled, SendEvents, Polarity, HoldTime, TimeChanged FROM DigitalInputs ORDER BY Address", function (err, row) {
                if (err !== null) {
                    logger.error('Digital Inputs - Initialize Error (Select)=' + JSON.stringify(err));
                }
                else {
                    UpdateDigitalInputConfiguration(row.Address, row.Name, row.Value, row.Enabled, row.SendEvents, row.Polarity, row.HoldTime, row.TimeChanged, io, logger);
                    logger.debug("Digital Inputs - [Value INITIAL from dB] Digital Input[" + (parseInt(row.Address)+1) + "] '" + row.Name + "' Value=" + row.Value);
                    digitalInputsArray[row.Address].TempValue = row.Value;
                    digitalInputsArray[row.Address].HoldTimer = 0;// This should be 0 to start
                }
            }, function () {
                // Digital Inputs read from table
                if (typeof callback == "function") {
                    logger.info('Digital Inputs - Initialized from existing database table');
                    callback();
                }
            });
        }
    });
}

// Adjust the digitalInputsArray
module.exports.UpdateDigitalInputConfiguration = UpdateDigitalInputConfiguration;
function UpdateDigitalInputConfiguration(Address, Name, Value, Enabled, SendEvents, Polarity, HoldTime, TimeChanged, io, logger) {
    digitalInputsArray[Address].Name = Name;
    digitalInputsArray[Address].Value = Value;
    digitalInputsArray[Address].Enabled = Enabled;
    digitalInputsArray[Address].SendEvents = SendEvents;
    digitalInputsArray[Address].Polarity = Polarity;
    digitalInputsArray[Address].HoldTime = HoldTime;
    digitalInputsArray[Address].TimeChanged = TimeChanged;
    sendValueDigitalInputs(io, logger);// Update the Digital Inputs configuration
}

// Intervalled processing of digital inputs
var processCounter = 0;
var processTotalTime = 0;
exports.ProcessDigitalInputs = function (db, logger, io, netSnmp, ledManager, callback) {
    timeStart = moment();
    
    var index;// This is an index to digital I/O point - accounts for first 24 bits being at a higher location that the second 24 bits
    var fileIndex;// This is an index to the GPIO location - it's the index + the GPIO offset
    var offset = 0;
    var timeChanged = moment();
    try {
        for (index = 0; index < DIGITAL_INPUTS_POINTS; index++) {
            // Figure file to read input value
            //#region File name logic
            // This f'ed up logic is that first 24 I/O points are higher than the next 24 I/O points
            if (offset < 24) {
                fileIndex = DIGITAL_INPUTS_BASEGPIO + index + 24;
            }
            else {
                fileIndex = DIGITAL_INPUTS_BASEGPIO + index - 24;
            }
            offset++;
            //#endregion File name logic
            
            // Only read value if the I/O point is enabled
            if (digitalInputsArray[index].Enabled === "TRUE") {
                // Read raw value from file
                //  If the raw value has changed then we'll ahve to do stuff
                //#region Read raw value
                data = fs.readFileSync(DIGITAL_INPUTS_LOCATION + fileIndex + "/value");
                readValue = String(data).replace(/(\r\n|\n|\r)/gm, "");
                
                // Normally Closed vs Normally Open
                if (digitalInputsArray[index].Polarity == "Normally Open") {
                    if (readValue === "1") {
                        readValue = "0";
                    } else {
                        readValue = "1";
                    }
                }
                //#endregion Read raw value
                
                if ((digitalInputsArray[index].Value != readValue) || (digitalInputsArray[index].HoldTime != 0)) {
                    // Filter logic
                    //  - We ignore non changes in digital values
                    //  - But we need to go through the logic when a hold timer is being used
                    //#region Filter logic                  
                    if (digitalInputsArray[index].HoldTime > 0) {
                        logger.trace("Digital Inputs - [Filter: HoldTimer Used(" + digitalInputsArray[index].HoldTime + ")] Digital Input[" + (index+1) + "] old value[array]=" + digitalInputsArray[index].Value + " new value[read]=" + readValue);
                    } else {
                        logger.trace("Digital Inputs - [Filter:  Value Changed] Digital Input[" + (index+1) + "] old value[array]=" + digitalInputsArray[index].Value + " new value[read]=" + readValue);
                    }
                    //#endregion Filter logic
                    
                    // HoldTime logic
                    //  - A non-zero value in the HoldTimer variable means that the HoldTimer is active
                    //  - Start the timer if there was a change and the timer wasn't previously started
                    //  - If the timer was previously started, then check if the 
                    //#region HoldTime logic
                    var HoldTimeValid = false;
                    var HoldTimeChanged = 0;
                    if (digitalInputsArray[index].HoldTime > 0) {
                        // We are using holdtimes ...
                        if (digitalInputsArray[index].Value != readValue) {
                            // Value has changed ...
                            if (digitalInputsArray[index].HoldTimer === 0) {
                                // HoldTimer not started, so start it
                                digitalInputsArray[index].HoldTimer = timeChanged;// Start the timer
                                logger.info("Digital Inputs - [HOLD TIMER - HoldTimer=" + parseFloat(digitalInputsArray[index].HoldTime).toFixed(2) + "s, Timer=STARTED, Valid=FALSE] Digital Input[" + (index+1) + "] '" + digitalInputsArray[index].Name + "'");
                                io.sockets.emit("DigitalInputHoldTime", { "DigitalInput": index, "HoldTime": "HOLDING" });
                            } else {
                                HoldTimeChanged = (timeChanged - digitalInputsArray[index].HoldTimer) / 1000;
                                if (HoldTimeChanged >= digitalInputsArray[index].HoldTime) {
                                    logger.info("Digital Inputs - [HOLD TIMER - HoldTimer=" + parseFloat(digitalInputsArray[index].HoldTime).toFixed(2) + "s, Timer=" + parseFloat(HoldTimeChanged).toFixed(2) + ", HoldTimeValid=TRUE] Digital Input[" + (index+1) + "] '" + digitalInputsArray[index].Name + "'");
                                    io.sockets.emit("DigitalInputHoldTime", { "DigitalInput": index, "HoldTime": "ON" })
                                    HoldTimeValid = true;
                                    (function (index) {
                                        setTimeout(function () {
                                            io.sockets.emit("DigitalInputHoldTime", { "DigitalInput": index, "HoldTime": "OFF" })
                                        }, 1000);
                                    })(index);
                                    digitalInputsArray[index].HoldTimer = 0;// Set hold timer to 0
                                } else {
                                    logger.info("Digital Inputs - [HOLD TIMER - HoldTimer=" + parseFloat(digitalInputsArray[index].HoldTime).toFixed(2) + "s, Timer=" + parseFloat(HoldTimeChanged).toFixed(2) + ", HoldTimeValid=FALSE] Digital Input[" + (index+1) + "] '" + digitalInputsArray[index].Name + "'");
                                    io.sockets.emit("DigitalInputHoldTime", { "DigitalInput": index, "HoldTime": "HOLDING" })
                                }
                            }
                        } else {
                            // Value has either returned to the same value or hasn't changed, so reset the hold timer
                            if (digitalInputsArray[index].HoldTimer !== 0) {
                                io.sockets.emit("DigitalInputHoldTime", { "DigitalInput": index, "HoldTime": "OFF" })
                                logger.trace("Digital Inputs - [HOLD TIMER - HoldTimer=" + parseFloat(digitalInputsArray[index].HoldTime).toFixed(2) + "s, Timer=RESET, HoldTimeValid=FALSE] Digital Input[" + (index+1) + "] '" + digitalInputsArray[index].Name + "'");
                                digitalInputsArray[index].HoldTimer = 0;
                            }
                        }
                    } else {
                        // Not using a hold time ...
                        HoldTimeValid = true;
                        logger.trace("Digital Inputs - [HoldTimer=NOT_USED] Digital Input[" + (index + 1) + "] '" + digitalInputsArray[index].Name + "'");
                    }
                    //#endregion HoldTime logic
                    
                    // Publish logic
                    //  - If the value has changed and the hold timer logic has been met, then change the value            
                    //#region Publish logic
                    if ((digitalInputsArray[index].Value != readValue) && HoldTimeValid) {
                        
                        // Change is valid ... 
                        digitalInputsArray[index].Value = readValue;
                        digitalInputsArray[index].TimeChanged = timeChanged;
                        
                        // Update real-time value, including SNMP because of threshold change
                        sendSocketSnmpSmtp(digitalInputsArray[index], db, io, logger, netSnmp)
                        
                        db.run("UPDATE DigitalInputs SET Value='" + digitalInputsArray[index].Value 
                            + "', TimeChanged='" + digitalInputsArray[index].TimeChanged 
                            + "' WHERE Address = '" + index + "'", 
                            function () {
                        });
                        
                        logger.info("Digital Inputs - [THRESHOLD UPDATE] Digital Input[" + (index + 1) + "] '" + digitalInputsArray[index].Name + "' Value=" + digitalInputsArray[index].Value + " HoldTime=" + (digitalInputsArray[index].HoldTime == 0?"0":HoldTimeChanged.toFixed(2)) + "seconds");
                        logger.debug("Digital Inputs - [DATABASE UPDATE] Digital Input[" + (index + 1) + "] '" + digitalInputsArray[index].Name + "' New Value=" + digitalInputsArray[index].Value);
                        logger.trace("Digital Inputs - [DATABASE UPDATE] Digital Input[" + (index + 1) + "] =" + JSON.stringify(digitalInputsArray[index]));
                    } else {
                        if (!HoldTimeValid) {
                            //var TempDigital = JSON.parse(JSON.stringify(digitalInputsArray[index]));
                            //TempDigital.Value = readValue;
                            //sendValueDigitalInput("DigitalInput", TempDigital, io, logger);

                            logger.trace("Digital Inputs - [REAL-TIME UPDATE - Value Changed but HoldTimerValid=FALSE] Digital Input[" + (index + 1) + "] '" + digitalInputsArray[index].Name + "' New value=" + digitalInputsArray[index].Value);
                        } 
                    }
                //#endregion Publish logic

                }
            } // try { Processing }
        }// if (digitalInputsArray[index].Enabled === "TRUE")
    }//  for (index = 0; index < DIGITAL_INPUTS_POINTS; index++)
    catch (error) {
        logger.error('Digital Inputs - Process Error (Read)=' + JSON.stringify(error));

    }
    finally {
        callback(digitalInputsArray);
    }
}

// Initialize the snmpHostSessionsArray used for send SNMP messages
var SnmpHostSessionsArray = [];// Instance array for list of SNMP host sessions
exports.SetSnmpHostSessionsArray = function (snmpHostSessions, logger, callback) {
    SnmpHostSessionsArray = snmpHostSessions.slice(0);// Copy array
    logger.debug("Digital Inputs - Initialized SNMP Host Sessions");
    
    if (typeof callback == "function") {
        callback();
    }
}

// Send updates to clients
function sendSocketSnmpSmtp(digitalInput, db, io, logger, netSnmp) {
    // SOCKET.IO: Send changed value to all attached clients
    sendValueDigitalInput("DigitalInput", digitalInput, io, logger);
    
    // SNMP: Send SNMP Trap/Notification if threshold(s) crossed
    sendSNMP(digitalInput, io, logger, netSnmp);

    // SMTP: Send SMTP message if threshold(s) crossed
    sendSMTP(digitalInput, io, logger)
}

function sendValueDigitalInput(dataType, data, io, logger) {
    io.sockets.emit(dataType, data);
}

function sendValueDigitalInputs(io, logger) {
    enabled = 0;
    for (i = 0; i < digitalInputsArray.length; i++) {
        if (digitalInputsArray[i].Enabled === "TRUE") enabled++;
    }
    io.sockets.emit("DigitalInputs", { "DigitalInputsTotal": digitalInputsArray.length, "DigitalInputsEnabled": enabled })
}

function sendSNMP(ioPoint, io, logger, netSnmp) {
    // SNMP definitions - also refer to the TASC-SUMMIT.MIB file for detailed information
    if (ioPoint.Enabled == "FALSE") return;
    if (ioPoint.SendEvents == "FALSE") return;
    
    address = parseInt(ioPoint.Address) + 1;// To overcome concatenation
    logger.trace("Digital Inputs - Sending SNMP Trap for Digital Input[" + address + "] '" + ioPoint.Name + "'");
    
    // Set up the SNMP trap    
    var trapOid = "1.3.6.1.4.1.11902.3.1.1000.1000.0." + (address - 1 + 1000);
    var varbinds = [
        {
            // Timestamp
            oid: "1.3.6.1.4.1.11902.3.1." + (address) + ".0.1",
            type: netSnmp.ObjectType.OctetString,
            value: new Buffer(moment().toString())
        },
        {
            // Address
            oid: "1.3.6.1.4.1.11902.3.1." + (address) + ".0.2",
            type: netSnmp.ObjectType.Integer,
            value: parseInt(ioPoint.Address) + 1
        },
        {
            // Name
            oid: "1.3.6.1.4.1.11902.3.1." + (address) + ".0.3",
            type: netSnmp.ObjectType.OctetString,
            value: new Buffer(ioPoint.Name)
        },
        {
            // Value ("ON" or "OFF")
            oid: "1.3.6.1.4.1.11902.3.1." + (address) + ".0.4",
            type: netSnmp.ObjectType.OctetString,
            value: new Buffer((ioPoint.Value === "1") ? "ON":"OFF")
        },
        {
            // Status (1=ON, 0=OFF)
            oid: "1.3.6.1.4.1.11902.3.1." + (address) + ".0.5",
            type: netSnmp.ObjectType.Integer,
            value: (ioPoint.Value === "1") ? 1:0
        },
        {
            // Polarity (1=Normally Closed, 0=Normally Open)
            oid: "1.3.6.1.4.1.11902.3.1." + (address) + ".0.6",
            type: netSnmp.ObjectType.Integer,
            value: (ioPoint.Polarity === "Normally Closed") ? 1: 0
        },
        {
            // Hold Time
            oid: "1.3.6.1.4.1.11902.3.1." + (address) + ".0.7",
            type: netSnmp.ObjectType.Integer,
            value: parseInt(ioPoint.HoldTime)
        },
    ];
    
    // Send the SNMP notification
    for (i = 0; i < SnmpHostSessionsArray.length; i++) {
        // Skip if this host is not enabled
        if (SnmpHostSessionsArray[i].Enabled === "FALSE") continue;
        
        // Send trap to host ...
        IPAddress = SnmpHostSessionsArray[i].Session.target;
        logger.debug("Digital Inputs - Sending to SNMP Host @ " + IPAddress + " - Digital Input[" + varbinds[1].value + "] '" + varbinds[2].value + "' Value=" + varbinds[4].value);
        SnmpHostSessionsArray[i].Session.trap(trapOid, varbinds, function (error) {
            if (error)
                logger.error("Digital Inputs - Send SNMP Error=" + error);
        });
    }
}

function sendSMTP(ioPoint, io, logger) {
    if (ioPoint.Enabled == "FALSE") return;
    if (ioPoint.SendEvents == "FALSE") return;
    // NOTE: Decision to send email is decided within SMTP module
    
    // Set up the SMTP Email message
    var message = [];
    address = parseInt(ioPoint.Address) + 1;// To overcome concatenation
    var event = "'" + ioPoint.Name + "' has changed to status=" + ((ioPoint.Value === "1") ? "ON":"OFF");
    message += moment().toString() + "\n";
    message += "Address=" + (parseInt(ioPoint.Address) + 1) + "\n";
    message += "Name=" + ioPoint.Name + "\n";
    message += "Value=" + ((ioPoint.Value === "1") ? "ON":"OFF") + "\n";
    message += "Status=" + ((ioPoint.Value === "1") ? 1:0) + "\n";
    message += "Polarity=" + ((ioPoint.Polarity === "Normally Closed") ? 1: 0) + "\n";
    message += "Hold Time=" + (parseInt(ioPoint.HoldTime)) + "\n"
    
    var ioInfo = "Digital Input[" + address + "] '" + ioPoint.Name + "'";
    
    logger.info("Digital Inputs - Sending SMTP Event for Digital Input[" + address + "] '" + ioPoint.Name + "' Value=" + ((ioPoint.Value === "1") ? "ON":"OFF"));
    SmtpManager.SendSmtp(message, ioInfo, event,function (result){
        logger.trace("Digital Inputs - SMTP Email Event Response for Digital Input[" + address + "]: " + result.result);
    })
}